<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://code.jquery.com/jquery-3.7.1.js"
        integrity="sha256-eKhayi8LEQwp4NKxN+CfCh+3qOVUtJn3QNZ0TciWLP4=" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.min.js"
        integrity="sha384-+sLIOodYLS7CIrQpBjl+C7nPvqq+FbNUBDunl/OZv93DB7Ln/533i8e/mZXLi/P+"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>

    <title>Task 30.10</title>
</head>

<body>
    <div class="container mt-4">
        <form id="login-form">
            <div class="form-group">
                <label for="input-username">Username</label>
                <input type="text" class="form-control" id="input-username" aria-describedby="emailHelp"
                    placeholder="Enter username">
                <small id="emailHelp" class="form-text text-muted">We'll never share your username with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="input-password">Password</label>
                <input type="password" class="form-control" id="input-password" placeholder="Password">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>

</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    var gLoginForm = document.getElementById("login-form");
    var gXmlHttpLogin = new XMLHttpRequest();
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    gLoginForm.addEventListener("submit", (paramEvent) => {
        // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
        paramEvent.preventDefault();
        console.log("Đã hủy bỏ phương thức xử lý submit mậc định");

        // Tiếp theo thực hiện 4 bước để gọi api login
        // Bước 1: Thu thập dữ liệu và đẩy vào object
        var vLoginInfo = collectData();
        console.log(vLoginInfo);
        // Bước 2: Validate dữ liệu, nếu dữ liệu hợp lệ thì chuyển sang bước 3, 4
        var vValidateData = validateData(vLoginInfo);
        if (vValidateData == true) {
            console.log("Chuẩn bị chạy bước 3, 4");
            // Bước 3: Gọi API
            callAPILogin(vLoginInfo);
            // Bước 4: Xử lý kết quả trả về
            xuLyKetQuaTraVe();
        }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu
    function collectData() {
        var vLoginInfo = {
            username: "",
            password: ""
        }
        var vInputEmailElement = document.getElementById("input-username");
        vLoginInfo.username = vInputEmailElement.value.trim();

        var vInputPasswordElement = document.getElementById("input-password");
        vLoginInfo.password = vInputPasswordElement.value.trim();
        return vLoginInfo;
    }

    // Hàm kiểm tra dữ liệu hợp lệ
    function validateData(paramLoginInfo) {
        if (paramLoginInfo.username.length < 4) {
            alert("Username phải có tối thiểu 4 ký tự");
            return false;
        }

        if (paramLoginInfo.password.length < 6) {
            alert("Mật khẩu phải có tối thiểu 6 ký tự");
            return false;
        }

        return true;
    }

    // Hàm gọi API login
    function callAPILogin(paramLoginInfo) {
        "use strict";
        //base url
        const vParams = new URLSearchParams(paramLoginInfo);

        // create a request
        gXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
        gXmlHttpLogin.send();
    }

    // hàm xử lý kết quả trả về
    function xuLyKetQuaTraVe() {
        gXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == 404){
                    alert("Quá trình login thất bại");
                } else if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // Bước 4: Xử lý kết quả trả về.
                    var vLoginInfo = gXmlHttpLogin.responseText;
                    var vLoginObject = JSON.parse(vLoginInfo);
                    console.log(vLoginObject);
                    if (vLoginObject[0].fullname != null) {
                        alert("Login thành công");
                    } else {
                        alert("Login thất bại");
                    }
                }
            }
    }
</script>

</html>